﻿namespace YandexSpeak {
	#region Библиотеки
	using System;
	using System.Net;
	#endregion
	#region Параметры синтезируемого голоса
	// Голос. иХ МНОГО, ВЫБРАЛ ИНТЕРЕСНЫЕ.
	public enum Speaker { oksana, jane, alyss, zahar };
	// Настроение
	public enum Emotion { good, neutral, evil }
	// Качество озвучки
	public enum Quality { hi, lo };
	// Формат звукового файла получаемого от яндекса, mp3 не озвучивается средствами .net
	public enum Format { wav, mp3 };
	#endregion
	//  класс для спич апи яндекса
	// Для проверки https://webasr.yandex.net/ttsdemo.html
	public static class YandexSpeechAPI {
		#region Константы
		// Ключ который в личном кабинете разработчика яндекса и должен быть привязан там же к сервису Speech IPI cloud
		// Для регистрации https://passport.yandex.ru/auth?origin=apikeys&retpath=https%3A%2F%2Fdeveloper.tech.yandex.ru%2F
		// кЛЮЧ НИЖЕ НАДО ЗАМЕНИТЬ НА ВАШ. мОЙ ПРИВЕДЕН КАК ОБРАЗЕЦ И НЕ БУДЕТ РАБОТАТЬ, ОН БЫЛ ИЗМЕНЕН НА СЛУЧАЙНЫЙ.
		private const string API_KEY = "bfb18c83-d1b4-42a1-bba8-ac5f52034b1a";
		#endregion
		#region Публичное
		// Делаем запрос на яндекс
		public static byte[] Speak(string text, Speaker speaker = Speaker.oksana, Emotion emotion = Emotion.good, double speed = 1.0, Quality quality = Quality.hi, Format format = Format.wav) {
			try {
				// Если нет текста то возвращаем нул
				if (string.IsNullOrEmpty(text)) { return null; }
				// Адрес для скачивания файла
				string url = "https://tts.voicetech.yandex.net/generate";
				// Текст
				url += "?text=" + text;
				// Голос: 
				url += "&lang=ru-RU&speaker=" + speaker;
				// Настроение
				url += "&emotion=" + emotion;
				// Скорость: 1.0 норма, 0.5 медленно, 2.0 быстро
				url += "&speed=" + speed.ToString().Replace(",", ".");
				// Качество: high, low
				url += "&quality=" + quality;
				// Формат файла: wav, mp3
				url += "&format=" + format;
				// Ключ разработчика яндекса
				url += "&key=" + API_KEY;
				// Создаем вебклиент
				WebClient cl = new WebClient();
				// Скачиваем файл как массив байтов
				byte[] ret = cl.DownloadData(url);
				// Возвращаем массив байтов
				return ret;
			}
			// Если ошибка то возвращаем нул
			catch { return null; }
		}
		#endregion
	}
}